/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.person.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class KreditinstitutUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String bankleitzahl;

    public java.lang.String getBankleitzahl(){
      return bankleitzahl;
    }


  public KreditinstitutUK(
java.lang.String bankleitzahl
  ) {
    super();


      this.bankleitzahl = bankleitzahl;
      }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((bankleitzahl == null) ? 0 : bankleitzahl.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            KreditinstitutUK other = (KreditinstitutUK) obj;

                if (bankleitzahl == null) {
          if (other.bankleitzahl != null) {
            return false;
          }
        } else if (!bankleitzahl.equals(other.bankleitzahl)) {
          return false;
        }
        
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return KreditinstitutConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(KreditinstitutConstants.MESSAGE_KEY_ENTITY_EINZAHL, KreditinstitutConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL, bankleitzahl));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "KreditinstitutUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"bankleitzahl="+bankleitzahl
                                    ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(bankleitzahl);
     return list;
   }

            public static <E extends Kreditinstitut> java.util.Map<KreditinstitutUK, E> mappeKreditinstitutNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Kreditinstitut::getKreditinstitutUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Kreditinstitut, KreditinstitutUK> getKreditinstitutToUKFunction() {
                return Kreditinstitut::getKreditinstitutUK;
                }

}
